local Reverse = string.find(GAMESTATE:GetPlayerState(pn):GetPlayerOptionsString("ModsLevel_Preferred"), "Reverse");
local fieldWidth = 32+27+32+35+32+27+32
local t = Def.ActorFrame{

--Stage background
	Def.Quad {
		InitCommand=function(self)
			self:halign(0)
			self:valign(1)
			self:zoomto(217,2048)
			self:diffuse(color("#000000DD"))
			self:addx(99.5 - 16)

			if Reverse then
				self:addrotationx(0)
			else
				self:addrotationx(180)
			end
		end
	};

--Stage left
	Def.Sprite {
		Texture="Stage/stage left";
		InitCommand=function(self)
			self:zoom(0.44444444)
			self:addx(99.5 - 16)
			self:halign(1)
			self:valign(1)

			if Reverse then
				self:addy(76)
			else
				self:addy(-76):addrotationx(180)
			end
		end
	};

--Stage right
	Def.Sprite {
		Texture="Stage/stage right " .. tostring(NOTESKIN:GetMetric("NoteskinPreferences","RightStageChoice"));
		InitCommand=function(self)
			self:zoom(0.44444444)
			self:addx(fieldWidth + 99.5 - 16)
			self:halign(0)
			self:valign(1)

			if Reverse then
				self:addy(76)
			else
				self:addy(-76):addrotationx(180)
			end
		end
	};

--Health bar background
	Def.Sprite {
			Name="Health";
			Texture="Stage/health bg";
			Frame0000=0;
			Delay0000=1;
			InitCommand=function(self)
			local health = STATSMAN:GetCurStageStats():GetPlayerStageStats(pn):GetCurrentLife()
				self:zoom(0.44444444):zoomx(0.44444444):diffusealpha(1):addx(315.5)

				if Reverse then
					self:addy(-86)
				else
					self:addy(86):addrotationx(180)
				end
			end,
		};

--Health bar (over 40% health)
	Def.Sprite {
			Name="Health fill";
			Texture="Stage/health fill";
			Frame0000=0;
			Delay0000=1;
			InitCommand=function(self)
			local health = STATSMAN:GetCurStageStats():GetPlayerStageStats(pn):GetCurrentLife()
				self:zoom(0.44444444):zoomx(0.44444444):diffusealpha(1):addx(315.5):croptop(health)

				if Reverse then
					self:addy(-86)
				else
					self:addy(86):addrotationx(180)
				end
			end,
			JudgmentMessageCommand=function(self)
			local health = STATSMAN:GetCurStageStats():GetPlayerStageStats(pn):GetCurrentLife()
				if health >= 0.4 then
					self:stoptweening():decelerate(0.128):diffusealpha(1):croptop( 1 - health )
				else
					self:stoptweening():decelerate(0.128):diffusealpha(0):croptop( 1 - health )
				end
			end
		};

--Notefield laser graphic
	Def.Sprite {
		Texture="Lasers/laser " .. tostring(NOTESKIN:GetMetric("NoteskinPreferences","LaserColor"));
		Frame0000=0;
		Delay0000=1;
		InitCommand=function(self)
			--Flip vertically for upscroll
			if Reverse then
				self:vertalign(bottom):zoomto(32,480):diffusealpha(0):addx(99.5)
			else
				self:vertalign(bottom):zoomto(32,480):diffusealpha(0):addx(99.5):addrotationx(180)
			end
		end,
		PressCommand=NOTESKIN:GetMetricA('ReceptorPressLight', 'PressCommand');
		LiftCommand=NOTESKIN:GetMetricA('ReceptorPressLight', 'LiftCommand');
		NoneCommand=NOTESKIN:GetMetricA('ReceptorArrow', 'NoneCommand');
	};


--Judgeline
	Def.Sprite {
		--Texture specified by "JudgelineColour" in metrics
		Texture="Stage/judgeline";
		Frame0000=0;
		Delay0000=1;
		InitCommand=function(self)
			if Reverse then
				self:halign(0):valign(1):addx(99.5 - 16):zoom(0.4444444)
			else
				self:halign(0):valign(1):addx(99.5 - 16):zoom(0.4444444):addrotationx(180)
			end
		end,
		NoneCommand=NOTESKIN:GetMetricA('ReceptorArrow', 'NoneCommand');
		PressCommand=NOTESKIN:GetMetricA('ReceptorArrow', 'NoneCommand');
	};

--Receptor button idle
	Def.Sprite {
		Texture="Receptors/L white idle " .. tostring(NOTESKIN:GetMetric("NoteskinPreferences","KeyStyleChoice"));
		Frame0000=0;
		Delay0000=1;
		InitCommand=function(self)
			--Offset position slightly so it reaches the screen bottom at default settings
			--Keep transparency at 0 unless button is held
			--Also flip vertically for upscroll
			if Reverse then
				self:valign(0):zoomto(32,76):diffusealpha(1):addx(99.5)
			else
				self:valign(0):zoomto(32,76):diffusealpha(1):addx(99.5):addrotationx(180)
			end
		end,
		PressCommand=function(self)
			self:diffusealpha(1)
		end,
		LiftCommand=function(self)
			self:diffusealpha(1)
		end,
		NoneCommand=function(self)
			self:diffusealpha(1)
		end
	};

--Receptor button pressed
	Def.Sprite {
		Texture="Receptors/L white pressed " .. tostring(NOTESKIN:GetMetric("NoteskinPreferences","KeyStyleChoice"));
		Frame0000=0;
		Delay0000=1;
		InitCommand=function(self)
			--Offset position slightly so it reaches the screen bottom at default settings
			--Keep transparency at 0 unless button is held
			--Also flip vertically for upscroll
			if Reverse then
				self:valign(0):zoomto(32,76):diffusealpha(0):addx(99.5)
			else
				self:valign(0):zoomto(32,76):diffusealpha(0):addx(99.5):addrotationx(180)
			end
		end,
		PressCommand=function(self)
			--Stoptweening to prevent tween overload/artifacts. Delay visibility to create less distracting visual
			--Without stoptweening() the tweens would overload and queue up when spamming a key and it would look weird.
			self:stoptweening():linear(.016):diffusealpha(1)
		end,
		LiftCommand=function(self)
			--Stoptweening to prevent tween overload/artifacts. Delay fadeout to create less distracting visual
			--Without stoptweening() the tweens would overload and queue up when spamming a key and it would look weird.
			self:stoptweening():sleep(.032):linear(.064):diffusealpha(0)
		end,
		NoneCommand=function(self)
			self:diffusealpha(0)
		end
	};

};

return t;