local Reverse = string.find(GAMESTATE:GetPlayerState(pn):GetPlayerOptionsString("ModsLevel_Preferred"), "Reverse");
local button = Var "Button"

--Define buttons as column numbers(left to right)
local mapping_seven = {
	Key1 = 1,
	Key2 = 2,
	Key3 = 3,
	Key4 = 4,
	Key5 = 5,
	Key6 = 6,
	Key7 = 7
}

--Count columns(used below to isolate JudgmentMessageCommand to specific columns)
local function shouldBomb(column, count)
	if count == 7 then
		return mapping_seven[button] == column
	else
		return false
	end
end


local t = Def.ActorFrame{
	--This chaotic line makes sure the original aspect ratio for explosions are kept even when you scale the notefield with customize gameplay
	--Without this, the explosions would get squished or stretched when scaling the notefield
	--It scales the entire actorframe instead of the explosions themselves to make sure it doesn't interfere with the explosion tweens
	InitCommand=function(self)
		local keymode = getCurrentKeyMode()
			self:zoomx(1/playerConfig:get_data(pn_to_profile_slot(PLAYER_1)).GameplaySizes[keymode].NotefieldWidth)
			self:zoomy(1/playerConfig:get_data(pn_to_profile_slot(PLAYER_1)).GameplaySizes[keymode].NotefieldHeight)
			self:addx(-65)

			if Reverse then
				self:addrotationx(0)
			else
				self:addrotationx(180)
			end
	end,

--The following mess is supposed to hide hold explosions when the holds are 16ths or shorter,
--but it ends up hiding the effect on longer holds sometimes as well
	Def.Sprite {
		--Choose texture based on preferences in metrics.ini
		Texture="Bombs/_bomb" .. tostring(NOTESKIN:GetMetric("NoteskinPreferences","TapExplosionChoice"));
		Frames=Sprite.LinearFrames(12,0.256);
		W5Command=NOTESKIN:GetMetricA("Bom", "W5Command");
		W4Command=NOTESKIN:GetMetricA("Bom", "W4Command");
		W3Command=NOTESKIN:GetMetricA("Bom", "W3Command");
		W2Command=NOTESKIN:GetMetricA("Bom", "W2Command");
		W1Command=NOTESKIN:GetMetricA("Bom", "W1Command");
		JudgmentMessageCommand=function(self, params)
			if params.Type ~= "Hold" then return end
			if params.Judgment ~= "HoldNoteScore_Held" then return end
			if shouldBomb(params.FirstTrack, params.NumTracks) then
				local tn = params.TapNote
				local length = tn:GetHoldDuration()
				if length <= 0.25 then
					self:setstate(0):diffusealpha(1):blend("BlendMode_Add"):zoom(0.8):sleep(.255):diffusealpha(0)
				elseif length > 0.25 then
					self:diffusealpha(0)
				end
			end
		end
	};

};

return t;